<?php

/*

CometChat
Copyright (c) 2016 Inscripts
License: https://www.cometchat.com/legal/license

*/
include_once(dirname(dirname(dirname(__FILE__))).DIRECTORY_SEPARATOR."plugins.php");

if (file_exists(dirname(__FILE__).DIRECTORY_SEPARATOR."lang.php")) {
	include_once(dirname(__FILE__).DIRECTORY_SEPARATOR."lang.php");
}

if( checkplan('plugins','filetransfer') == 0){ exit;}
if(!checkMembershipAccess('filetransfer','plugins')){exit();}

if (empty($_GET['id'])) { exit; }

$basedata = '';
$toId = intval($_GET['id']);
$chatroommode = 0;
if (!empty($_GET['chatroommode'])) {
	$chatroommode = 1;
}

$embed = '';
$embedcss = '';

if (!empty($_GET['embed']) && $_GET['embed'] == 'web') {
	$embed = 'web';
	$embedcss = 'embed';
}

if (!empty($_GET['embed']) && $_GET['embed'] == 'desktop') {
	$embed = 'desktop';
	$embedcss = 'embed';
}

if (!empty($_REQUEST['callbackfn']) && $_REQUEST['callbackfn'] == 'mobileapp') {
  $embed = 'mobileapp';
}

$basedata = $_REQUEST['basedata'];

$cc_layout = 'docked';
if(!empty($_REQUEST['cc_layout'])){
  $cc_layout = $_REQUEST['cc_layout'];
}

$method = 'closeCCPopup';
$params = "'name':'filetransfer','roomid':'{$_REQUEST['id']}'";
if(!empty($cc_layout) && $cc_layout == 'docked'){
    $method = 'closeChatboxCCPopup';
    $params = "'name':'filetransfer','id':'{$_REQUEST['id']}',chatroommode:'{$chatroommode}'";
}
$message = $filetransfer_language[14];
$jQuerytag = getDynamicScriptAndLinkTags(array('type' => "core",'name' => 'jquery','callbakcfn' => $embed, 'ext' => 'js'));
$svgjs = getDynamicScriptAndLinkTags(array('type' => "core",'name' => 'svg', 'ext' => 'js'));
$csstag = getDynamicScriptAndLinkTags(array('type' => "plugin",'name' => 'filetransfer','layout' => $cc_layout,'ext' => 'css'));
$staticCDNUrl = STATIC_CDN_URL;
$baseURL = BASE_URL;
echo <<<EOD
<html>
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>
	{$svgjs}
	{$jQuerytag}
	<script>  $ = jQuery = jqcc; </script>
	{$csstag}
</head>

<body>

  	<div id="cometchat_dragandrophandler">
		<input  id="cometchat_fileupload" type="file" name="file1" />
		<div id="cometchat_uploadmsg">
			<div id="cometchat_filetransferUI"></div>
			<div class="cometchat_uploadtxt">
			{$message}
			</div>
		</div>
		<div id="cometchat_thumbnailimg" class="cometchat_hide"></div>
		<div id="cometchat_sendbtn" class="cometchat_hide"></div>
	</div>

<script>
	var tid = '{$toId}';
	var rowCount=0;

	function sendFileToServer(formData){
		jqcc('#cometchat_dragandrophandler').html('<img class="loaderbar" src="{$baseURL}images/loaderbar.gif">');
		var uploadURL ="{$baseURL}plugins/filetransfer/upload.php";
		var extraData ={};

		var jqXHR=jqcc.ajax({
			url: uploadURL,
			type: "POST",
			contentType:false,
			processData: false,
			cache: false,
			data: formData,
			success: function(data){
				location.reload();
				setTimeout(function(){
					$('#cometchat_uploadmsg').fadeIn();
					$('#cometchat_filetransferUI').removeClass('cometchat_hide');
				}, 100);
			}
		});
	}

	function handleFileUpload(files,obj){
		for (var i = 0; i < files.length; i++){
			var formData = new FormData();
			formData.append('file', files[i]);
			formData.append('to',tid);
			formData.append('chatroommode','{$chatroommode}');
			formData.append('basedata','{$basedata}');
			sendFileToServer(formData);
		}
	}

	function closeFileTransfer(){
		var controlparameters = {'type':'plugins', 'name':'filetransfer', 'method':'{$method}', 'params':{{$params}}};
		controlparameters = JSON.stringify(controlparameters);
		if(typeof(parent) != 'undefined' && parent != null && parent != self){
			parent.postMessage('CC^CONTROL_'+controlparameters,'*');
		} else {
			window.opener.postMessage('CC^CONTROL_'+controlparameters,'*');
		}
	}

	$(function(){
		var obj = jqcc("#cometchat_dragandrophandler");
		$('#cometchat_filetransferUI').html(cometchat_svgs.uploadfile);

		obj.on("click", '#cometchat_fileupload', function (e) {
			e.stopPropagation();
		});

		obj.on('click',function(){
			if(jqcc('.blurimage').length == 0){
				jqcc('#cometchat_fileupload').click();
				jqcc('#cometchat_uploadmsg').fadeOut();
			}
		});

		jqcc("#cometchat_fileupload").change(function(){
			var files = jqcc('#cometchat_fileupload')[0].files;
			previewFile(files);
		});

		function previewFile(files) {
			let reader = new FileReader();
			for(var i=0;i<files.length;i++){
				reader.readAsDataURL(files[i]);
				var fileType = files[i].type;
				reader.onloadend = function() {
					var filetype = fileType.split('/');
					let img = document.createElement('img');
					switch (filetype[0]) {
						case 'image':
						img.src = reader.result;
						break;
						case 'video':
						img.src = "{$baseURL}plugins/filetransfer/images/videoicon.png";
						break;
						case 'application':
						img.src = "{$baseURL}plugins/filetransfer/images/fileicon.png";
						break;
						case 'audio':
						img.src = "{$baseURL}plugins/filetransfer/images/audioicon.png";
						break;
						case 'text':
						img.src = "{$baseURL}plugins/filetransfer/images/texticon.png";
						break;
						case '':
						img.src = "{$baseURL}plugins/filetransfer/images/fileicon.png";
						break;
						default:
						img.src = "{$baseURL}plugins/filetransfer/images/fileicon.png";
						break;
					}
					img.classList.add('blurimage');
					jqcc('#cometchat_filetransferUI').addClass('cometchat_hide');
					jqcc('#cometchat_thumbnailimg').html(img);
					jqcc('#cometchat_sendbtn').html(cometchat_svgs.send);
					jqcc('#cometchat_thumbnailimg, #cometchat_sendbtn').removeClass('cometchat_hide');
				}
				jqcc('#cometchat_sendbtn').on('click', function(){
					setTimeout(function(){
						$('#cometchat_thumbnailimg').remove();
						$("#cometchat_sendbtn").remove();
						handleFileUpload(files,obj);
					},500);
				});
			}
		}

		obj.on('dragenter', function (e){
			e.stopPropagation();
			e.preventDefault();
			jqcc(this).css('background-color', 'gray');
		});

		obj.on('dragleave', function (e){
			e.stopPropagation();
			e.preventDefault();
			jqcc(this).css('background-color', '');
		});

		obj.on('dragover', function (e){
			e.stopPropagation();
			e.preventDefault();
		});

		obj.on('drop', function (e){
			jqcc(this).css('background-color', '');
			e.preventDefault();
			var files = e.originalEvent.dataTransfer.files;
			jqcc('#cometchat_uploadmsg').fadeOut();
			previewFile(files);
		});

		jqcc(document).on('dragenter', function (e){
			e.stopPropagation();
			e.preventDefault();
		});

		jqcc(document).on('dragover', function (e){
			e.stopPropagation();
			e.preventDefault();
		});

		jqcc(document).on('drop', function (e){
			e.stopPropagation();
			e.preventDefault();
		});
	});

	</script>
</body>
</html>
EOD;
